Redmine - Defect #19558

Mail handler should not ignore emails with x-auto-response-suppress header
Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Email receiving Estimated time: 0.00 hour
Target version: 3.0.2

Resolution: Fixed Affected version: 3.0.1
Description

| can see from the code that certain values within x-auto-response-suppress headers in received mail make redmine ignore the mail.
It seems to me that this is not correct since the header is about suppressing (subsequent) auto responses, not about flagging the
current mail as auto response. See https://msdn.microsoft.com/en-us/library/ee219609%28v=exchg.80%29.aspx

For example, when adding redmine to an Exchange 2010 distribution list, it will always receive the header for mail sent via that list.

Related issues:
Related to Redmine - Patch #19322: Allow to ignore auto reply messages from E... Closed

Associated revisions

Revision 14159 - 2015-04-11 09:15 - Jean-Philippe Lang

Mail handler should not ignore emails with x-auto-response-suppress header (#19558).

Patch by Sebastian Paluch.

Revision 14209 - 2015-04-25 09:39 - Jean-Philippe Lang
Merged r14159 (#19558).

History

#1 - 2015-04-06 16:31 - Toshi MARUYAMA

- Related to Patch #19322: Allow to ignore auto reply messages from Exchange server added

#2 - 2015-04-06 16:34 - Toshi MARUYAMA

- Target version set to 3.0.2

#3 - 2015-04-06 16:36 - Toshi MARUYAMA

| don't know about Exchange, should #19322 be reverted?

#4 - 2015-04-06 16:56 - Moritz Schepp

... well the header x-auto-response-suppress is only used by exchange. As far as | understand the docs, the header doesn't identify auto-reponses. It
has been added as an exclusion pattern to the mail_handler for #10607. Afaik, it should'nt have been.

#5 - 2015-04-06 17:00 - Toshi MARUYAMA
- Status changed from New to Needs feedback

- Target version deleted (3.0.2)

| think #19322 is correct because Redmine 3.0.1 ignores only "oof" and "all".
source:tags/3.0.1/app/models/mail_handler.rb#L76

@QRignored_emails_headers = {
'X-Auto-Response-Suppress' => /(ooflall)/,
'Auto-Submitted' => /\Aauto- (replied|generated)/,

'X-Autoreply' => 'yes
}

http://serverfault.com/questions/277515/how-does-exchange-2010-prevent-auto-reply-loop
#6 - 2015-04-06 17:14 - Moritz Schepp

... S0 the header sais: "do not send auto replies to this email", it doesn't say "this email is an auto reply". Exchange seems to add the header to auto
replies (that's what the second answer on serverfault sais and it makes sense to prevent loops). That doesn't mean that the header's presence is an
indication for an auto reply. For example, Exchange adds the header to all mails sent to distribution list members (makes sense because some
recipient might always be on holiday and the sender usually doesn't care). Those would then be filtered by redmine.

#7 - 2015-04-06 18:29 - Toshi MARUYAMA
- Status changed from Needs feedback to New

- Target version set to 3.0.2

#8 - 2015-04-06 20:12 - Sebastian Paluch
- File mailer.patch added

well.. | dig a bit more on this and it seems that Moritz is right, not only the patch #19322 is wrong but the X-Auto-Response-Suppress header should
not be there in first place.

Detecting Outlook autoreply/out-of-office emails and X-Auto-Response-Suppress header
Detecting Outlook autoreply/out-of-office emails

Instead the outgoing emails, send by Redmine, should have the header set correctly.

Currently, the only related headers in outgoing emails that are set are (per Redmine 3.0.0):
X-Auto—-Response-Suppress: OOF

Auto-Submitted: auto-generated

This results in suppressing only out-of-office responses but all the rest (e.g. delivery reports) are coming in.
It should be:

X-Auto-Response-Suppress: All

Auto-Submitted: auto-generated

I my case the Redmine's mail box was full of undelivered reports (thousands of emails) that mail_handler was not handling correctly. Reverting
#19322 and applying attached mailer.patch should do the work.

#9 - 2015-04-06 20:17 - Sebastian Paluch
- File mailer.patch added

New patch doing both, removing the header from mail_handler and changing it in mailer.

#10 - 2015-04-08 11:24 - Moritz Schepp

Guys, thanks for looking into this!

#11 - 2015-04-11 09:15 - Jean-Philippe Lang

- Subject changed from Mail handler and x-auto-response-suppress to Mail handler should not ignore emails with x-auto-response-suppress header
- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Patch committed in r14159, thanks for digging into this.

#12 - 2015-04-25 09:40 - Jean-Philippe Lang

- Status changed from Resolved to Closed

#13 - 2018-04-24 17:49 - Fred B

| don't get this patch.. It turn the suppression from Out of Office to All?
In mailer.rb :

X-Auto-Response-Suppress' => 'OOF'

Become
'X-Auto-Response-Suppress' => 'All'
It should do the opposite. Only suppress OOF and turn the other mails into issues?

P.S. | came to this patche because on Redmine 2.4.3 some of the forwarded email are ignored.

Files

mailer.patch 1.18 KB 2015-04-06 Sebastian Paluch

mailer.patch 2.09 KB 2015-04-06 Sebastian Paluch
